//More information at: https://www.aeq-web.com/
#include <SPI.h>
#include <Ethernet.h>
//////////////////////Please modify following lines///////////////////////
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };                    //
byte ip[] = { 10, 1, 1, 99 };                                           //
byte gateway[] = { 10, 1, 1, 254 };                                     //
byte subnet[] = { 255, 255, 255, 0 };                                   //
//////////////////////////////////////////////////////////////////////////
EthernetServer server(80);                                              
int rl1_pin = 2; //Define relay pin 1
int rl2_pin = 3; //Define relay pin 2

int rl1_state = 0;
int rl2_state = 0;
String rl1_text = "OFF";
String rl2_text = "OFF";
String readString;

void setup() {
  pinMode(rl1_pin, OUTPUT);
  pinMode(rl2_pin, OUTPUT);
  Ethernet.begin(mac, ip, gateway, subnet);
  server.begin();
}

void loop() {
  EthernetClient client = server.available();
  if (client) {
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();

        if (readString.length() < 100) {
          readString += c;
        }

        if (c == 0x0D) {
          read_request();
          client.println("HTTP/1.1 200 OK"); //send new page
          client.println("Content-Type: text/html");
          client.println();
          client.println("<html>");
          client.println("<head>");
          client.println("<TITLE>Smarthome LED Control</TITLE>");
          client.println("</head>");
          client.println("<body>");
          client.println("<h1>LED-Strip Control Center</h1>");
          client.println("<hr>");
          client.println("<br>");
          client.println("<table border='1'>");
          client.println("<tr>");
          client.println("<th>Output 1</th>");
          client.println("<th>");
          client.println(rl1_text);
          client.println("</th>");
          client.println("<tr>");
          client.println("<tr>");
          client.println("<th>Output 2</th>");
          client.println("<th>");
          client.println(rl2_text);
          client.println("</th>");
          client.println("<tr>");
          client.println("<tr>");
          client.println("<th>");
          if (rl1_state == 1) {
            client.println("<a href=\"/?RL1OFF\"\">TURN LED1 OFF</a>");
          } else {
            client.println("<a href=\"/?RL1ON\"\">TURN LED1 ON</a>");
          }
          client.println("</th>");
          client.println("<th>");
          if (rl2_state == 1) {
            client.println("<a href=\"/?RL2OFF\"\">TURN LED2 OFF</a>");
          } else {
            client.println("<a href=\"/?RL2ON\"\">TURN LED2 ON</a>");
          }
          client.println("</th>");
          client.println("<tr>");
          client.println("</table>");
          client.println("</body>");
          client.println("</html>");
          delay(10);
          client.stop();
        }
      }
    }
  }
}

void read_request() {
  if (readString.indexOf("?RL1ON") > -1)
  {
    rl1_state = 1;
    rl1_text = "ON";
    digitalWrite(rl1_pin, HIGH);

  }
  else {
    if (readString.indexOf("?RL1OFF") > -1)
    {
      rl1_state = 0;
      rl1_text = "OFF";
      digitalWrite(rl1_pin, LOW);

    }
  }
  if (readString.indexOf("?RL2ON") > -1)
  {
    rl2_state = 1;
    rl2_text = "ON";
    digitalWrite(rl2_pin, HIGH);
  }
  else {
    if (readString.indexOf("?RL2OFF") > -1)
    {
      rl2_state = 0;
      rl2_text = "OFF";
      digitalWrite(rl2_pin, LOW);

    }
  }
  readString = "";
}
